<?php
/**
*
* @package install
* @version $Id: convert_mysbb1.php by saanina@gmail.com for phpbbarabia.com $
* @copyright (c) 2006 phpBB Group # support this convert in http://phpbbarabia.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* NOTE to potential convertor authors. Please use this file to get
* familiar with the structure since we added some bare explanations here.
*
* Since this file gets included more than once on one page you are not able to add functions to it.
* Instead use a functions_ file.
*
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

include($phpbb_root_path . 'config.' . $phpEx);
unset($dbpasswd);

/**
* $convertor_data provides some basic information about this convertor which is
* used on the initial list of convertors and to populate the default settings
*/
$convertor_data = array(
	'forum_name'		=> 'mysbb1.7.x',
	'version'		=> '1.7.0',
	'phpbb_version'		=> '3.0.2',
	'author'		=> '<a href="http://www.phpbbarabia.com/">phpBBarabia [saanina]</a>',
	'dbms'			=> $dbms,
	'dbhost'		=> $dbhost,
	'dbport'		=> $dbport,
	'dbuser'		=> $dbuser,
	'dbpasswd'		=> '',
	'dbname'		=> $dbname,
	'table_prefix'		=> 'MySBB_',
	'forum_path'		=> '../mysbb',
	'author_notes'		=> 'Will not convert anything related with permisions; do it manually after converting .',
);

/**
* $tables is a list of the tables (minus prefix) which we expect to find in the
* source forum. It is used to guess the prefix if the specified prefix is incorrect
*/
$tables = array(
	'ads',
	'announcement',
	'attach',
	'avater',
	'contactus_extensions',
	'contactus_messages',
	'emailmsgs',
	'ex',
	'group',
	'info',
	'member',
	'online',
	'pages',
	'pm',
	'pmfolder',
	'pmlists',
	'poll',
	'reply',
	'requests',
	'section',
	'sectionadmin',
	'sectiongroup',	
	'smiles',
	'style',
	'subject',
	'supermemberlogs',
	'today',
	'toolbox',
	'usertitle',
	'vote',
);

/**
* $config_schema details how the board configuration information is stored in the source forum.
*
* 'table_format' can take the value 'file' to indicate a config file. In this case array_name
* is set to indicate the name of the array the config values are stored in
* 'table_format' can be an array if the values are stored in a table which is an assosciative array
* (as per phpBB 2.0.x)
* If left empty, values are assumed to be stored in a table where each config setting is
* a column (as per phpBB 1.x)
*
* In either of the latter cases 'table_name' indicates the name of the table in the database
*
* 'settings' is an array which maps the name of the config directive in the source forum
* to the config directive in phpBB3. It can either be a direct mapping or use a function.
* Please note that the contents of the old config value are passed to the function, therefore
* an in-built function requiring the variable passed by reference is not able to be used. Since
* empty() is such a function we created the function is_empty() to be used instead.
*/
$config_schema = array(
	'table_name'	=>	'info',
	'table_format'	=>	'',
	'where'		=>	'id=1',
	'settings'	=>	array(
		//'allow_bbcode'			=> 'allow_bbcode',
		'allow_smilies'			=> 'smiles_show',
		//'allow_sig'			=> 'allow_sig',
		//'allow_namechange'		=> 'allow_namechange',
		//'allow_avatar_local'		=> 'allow_avatar',
		'allow_avatar_remote'		=> 'allow_avatar',
		'allow_avatar_upload'		=> 'upload_avatar',
		'board_disable'			=> 'board_close',
		'sitename'			=> 'mysbb_set_encoding(title)',
		'site_desc'			=> 'mysbb_set_encoding(title)',
		'session_length'		=> 'time_out',
		'board_email_sig'		=> 'mysbb_set_encoding(contactus_sig)',
		'posts_per_page'		=> 'perpage',
		'topics_per_page'		=> 'subject_perpage',
		//'enable_confirm'		=> 'enable_confirm',
		'board_email_form'		=> 'admin_email',
		'load_online'			=> 'who_enabled',
		'load_onlinetrack'		=> 'show_onlineguest',
		'max_post_chars'		=> 'post_text_max',
		'newest_username'		=> 'last_member',
		'newest_user_id'		=> 'last_member_id',
		'num_posts'			=> 'reply_number',
		'num_topics'			=> 'subject_number',
		'num_users'			=> 'member_number',

	)
);

/**
* $test_file is the name of a file which is present on the source
* forum which can be used to check that the path specified by the
* user was correct
*/
$test_file = 'pm.php';

if (!$get_info)
{
	// Overwrite maximum avatar width/height
	@define('DEFAULT_AVATAR_X_CUSTOM', get_config_value('avatar_max_width'));
	@define('DEFAULT_AVATAR_Y_CUSTOM', get_config_value('avatar_max_height'));



	$convertor = array(
		'test_file'			=> 'pm.php',

		'avatar_path'			=> get_config_value('download_path').'/avatar/',
		'avatar_gallery_path'		=> 'image/avatar/',
		'smilies_path'			=> 'image/avatar/',
		'upload_path'			=> get_config_value('download_path').'/',
		'thumbnails'			=> '',
		'ranks_path'			=> false, // mysbb1 had no config value for a ranks path

		// We empty some tables to have clean data available
		'query_first'			=> array(
			array('target', $convert->truncate_statement . SEARCH_RESULTS_TABLE),
			array('target', $convert->truncate_statement . SEARCH_WORDLIST_TABLE),
			array('target', $convert->truncate_statement . SEARCH_WORDMATCH_TABLE),
			array('target', $convert->truncate_statement . LOG_TABLE),
		),

//	with this you are able to import all attachment files on the fly. For large boards this is not an option, therefore commented 

		'execute_first'	=> '
			mysbb_check_username_collisions();
			import_avatar_gallery();
			mysbb_insert_forums();
			do_poll_options_convert();
		',

		'execute_last'	=> array('
			add_bots();
		', '
			update_folder_pm_count();
		', '
			update_unread_count();
		', '
			phpbb_convert_authentication(\'start\');
		', '
			phpbb_convert_authentication(\'first\');
		', '
			phpbb_convert_authentication(\'second\');
		', '
			phpbb_convert_authentication(\'third\');
		'),

		'schema' => array(

			array(
				'target'		=> ATTACHMENTS_TABLE,
				'primary'		=> 'attach.id',
				'query_first'	=> array('target', $convert->truncate_statement . ATTACHMENTS_TABLE),
				'autoincrement'	=> 'attach_id',

				array('attach_id',		'attach.id',			''),
				array('post_msg_id',		'attach.subject_id',		''),
				array('topic_id',		'subject.id',			''),
				array('in_message',		0,				''),
				array('is_orphan',		0,				''),
				array('poster_id',		'attach.u_id AS poster_id',	'mysbb_user_id'),
				array('physical_filename',	'attach.filepath',		'import_attachment'),
				array('real_filename',		'attach.filename',		'mysbb_set_encoding'),
				array('download_count',		'attach.visitor',		''),
				array('attach_comment',		'attach.temp',	array('function1' => 'mysbb_set_encoding', 'function2' => 'utf8_htmlspecialchars')),
				array('extension',		'attach.filename',		'mysbb_get_attachment_ext'),
				array('mimetype',		'attach.filepath',			'mimetype'),
				array('filesize',		'attach.filesize',			''),
				array('filetime',		'subject.native_write_time',			''),

				'where'			=> 'subject.id = attach.subject_id',
				'group_by'		=> 'attach.id'
			),



			array(
				'target'		=> EXTENSIONS_TABLE,
				'query_first'	=>  array('target', $convert->truncate_statement . EXTENSIONS_TABLE),
				'autoincrement'	=> 'extension_id',

				array('extension_id',			'ex.id',				''),
				array('extension',			'ex.Ex',				''),
				array('max_filesize',			'ex.max_size',				''),
			),




			array(
				'target'		=> RANKS_TABLE,
				'query_first'	=> array('target', $convert->truncate_statement . RANKS_TABLE),
				'autoincrement'	=> 'rank_id',

				array('rank_id',					'usertitle.id',			''),
				array('rank_title',					'usertitle.usertitle',	array('function1' => 'mysbb_set_encoding', 'function2' => 'utf8_htmlspecialchars')),
				array('rank_min',					'usertitle.posts',		''),


			),

			array(
				'target'		=> TOPICS_TABLE,
				'query_first'		=> array('target', $convert->truncate_statement . TOPICS_TABLE),
				'primary'		=> 'subject.id',
				'autoincrement'		=> 'topic_id',

				array('topic_id',				'subject.id',					''),
				array('forum_id',				'subject.section',				''),
				array('icon_id',				'subject.icon',				'get_icon_id'),
				array('topic_poster',				'subject.writer AS poster_id',	array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('topic_attachment',			'subject.attach_subject', ''),
				array('topic_title',				'subject.title',				'mysbb_set_encoding'),
				array('topic_text',				'subject.text',					'mysbb_prepare_message'),
				array('topic_time',				'subject.write_time',				''),
				array('topic_views',				'subject.visitor',				''),
				array('topic_replies',				'subject.reply_number',				''),
				array('topic_replies_real',			'subject.reply_number',				''),
				array('topic_last_post_id',			'subject.id',					'get_last_id_reply'),
				array('topic_status',				'subject.close',				'is_topic_locked'),
				array('topic_moved_id',				0,									''),
				array('topic_type',				'subject.id',					'mysbb_convert_topic_type'),
				array('topic_first_post_id',			'subject.id',					''),
				array('topic_last_view_time',	'		subject.reply_time',						''),
				array('poll_title',				'poll.qus',				array('function1' => 'null_to_str', 'function2' => 'mysbb_set_encoding', 'function3' => 'utf8_htmlspecialchars')),
				array('poll_start',				'subject.write_time',				'null_to_zero'),
				array('poll_length',				0,			''),
				array('poll_max_options',			1,									''),
				array('poll_vote_change',			0,									''),

				'left_join'		=>	array (	'subject LEFT JOIN poll ON subject.id = poll.subject_id AND subject.poll_subject = 1'
									),
			
			),



			array(
				'target'		=> TOPICS_WATCH_TABLE,
				'primary'		=> 'reply.id',
				'query_first'	=> array('target', $convert->truncate_statement . TOPICS_WATCH_TABLE),

				array('topic_id',				'reply.subject_id ',			''),
				array('user_id',				'reply.writer',	 array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('notify_status',			'1',		''),
				'where'		=> 'reply.subscribe = 1',
			),

			array(
				'target'		=> SMILIES_TABLE,
				'query_first'	=> array('target', $convert->truncate_statement . SMILIES_TABLE),
				'autoincrement'	=> 'smiley_id',

				array('smiley_id',				'smiles.id',				''),
				array('code',					'smiles.smile_short',						array('function1' => 'mysbb_smilie_html_decode', 'function2' => 'mysbb_set_encoding', 'function3' => 'utf8_htmlspecialchars')),
				array('emotion',				'smiles.smile_short',					'mysbb_set_encoding'),
				array('smiley_url',				'smiles.smile_path',				'import_smiley'),
				array('smiley_width',			'smiles.smile_path',				'get_smiley_width'),
				array('smiley_height',			'smiles.smile_path',				'get_smiley_height'),
				array('smiley_order',			'smiles.id',				''),
				array('display_on_posting',		'smiles.id',				'get_smiley_display'),

				'where'		=> 'smiles.smile_type = 0',
				'order_by'		=> 'smiles.id ASC',
			),



			array(
				'target'		=> POLL_VOTES_TABLE,
				'primary'		=> 'vote.id',
				'query_first'	=> array('target', $convert->truncate_statement . POLL_VOTES_TABLE),

				array('poll_option_id',			VOTE_CONVERTED,				''),
				array('topic_id',			'poll.subject_id',			''),
				array('vote_user_id',			'vote.member_id',			'mysbb_user_id'),
				array('vote_user_ip',			'',			''),

				'left_join'		=>	array (	'poll LEFT JOIN vote ON poll.id = vote.poll_id'
									),
			),


			array(
				'target'		=> POSTS_TABLE,
				'primary'		=> 'reply.id',
				'autoincrement'	=> 'post_id',
				'query_first'	=> array('target', $convert->truncate_statement . POSTS_TABLE),
				'execute_first'	=> '
					$config["max_post_chars"] = 0;
					$config["max_quote_depth"] = 0;
				',

				array('post_id',				'reply.id',	''),
				array('topic_id',				'reply.subject_id',	''),
				array('forum_id',				'subject.section',	''),
				array('poster_id',				'reply.writer',		array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('icon_id',				'reply.icon',		'get_icon_id'),
				array('poster_ip',				'',			''),
				array('post_time',				'reply.write_time',	''),
				array('enable_bbcode',				1,			''),
				array('',					0,			''),
				array('enable_smilies',				1,			''),
				array('enable_sig',				1,			''),
				array('enable_magic_url',			1,			''),
				array('post_username',				'reply.writer',		'mysbb_set_encoding'),
				array('post_subject',				'reply.title',		'mysbb_set_encoding'),
				array('post_attachment',			'reply.attach_reply', 	''),
			
				array('post_edit_user',				'reply.action_by',	array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),

				array('bbcode_uid',				'reply.write_time',	'make_uid'),
				array('post_text',				'reply.text',		'mysbb_prepare_message'),
				array('bbcode_bitfield',		'',				'get_bbcode_bitfield'),
				array('post_checksum',			'',				''),

				// Commented out inline search indexing, this takes up a LOT of time. :D
				// @todo We either need to enable this or call the rebuild search functionality post convert
/*				array('',						'',									'search_indexing'),
				array('',						'posts_text.post_text AS message',	''),
				array('',						'posts_text.post_subject AS title',	''),*/

				'where'			=>	'subject.id = reply.subject_id'
			),

			array(
				'target'		=> PRIVMSGS_TABLE,
				'primary'		=> 'pm.id',
				'autoincrement'	=> 'msg_id',
				'query_first'	=> array(
					array('target', $convert->truncate_statement . PRIVMSGS_TABLE),
					array('target', $convert->truncate_statement . PRIVMSGS_RULES_TABLE),
				),

				'execute_first'	=> '
					$config["max_post_chars"] = 0;
					$config["max_quote_depth"] = 0;
				',

				array('msg_id',				'pm.id',	''),
				array('root_level',			0,		''),
				array('author_id',			'pm.user_from AS poster_id',	array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('icon_id',			0,		''),
				array('author_ip',			'',		''),
				array('message_time',			'pm.date',	'mysbb_convert_time'),
				array('enable_bbcode',			1,	''),
				array('enable_smilies',			1,	''),
				array('enable_magic_url',		1,	''),
				array('enable_sig',			1,	''),
				array('message_subject',		'pm.title',		'mysbb_set_encoding'), // Already specialchared in 2.0.x
				array('message_attachment',		0, 	''),
				array('message_edit_reason',		'',	''),
				array('message_edit_user',		0,									''),
				array('message_edit_time',		0,									''),
				array('message_edit_count',		0,									''),

				array('bbcode_uid',			'pm.date AS post_time',	array('function1'=>'mysbb_convert_time', 'function2'=>'make_uid')),
				array('message_text',			'pm.text',		'mysbb_prepare_message'),
				array('bbcode_bitfield',		'',			'get_bbcode_bitfield'),
				array('to_address',			'pm.user_to',		array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_privmsgs_to_userid')),
				array('bcc_address',			'',			''),

				//'where'			=>	'privmsgs.privmsgs_id = privmsgs_text.privmsgs_text_id'
			),

			array(
				'target'		=> PRIVMSGS_FOLDER_TABLE,
				'primary'		=> 'member.id',
				'query_first'	=> array('target', $convert->truncate_statement . PRIVMSGS_FOLDER_TABLE),

				array('user_id',			'member.id',		'mysbb_user_id'),
				array('folder_name',			$user->lang['CONV_SAVED_MESSAGES'],	''),
				array('pm_count',			0,	''),

				//'where'			=> 'member.id <> -1',
			),

			// Inbox
			array(
				'target'		=> PRIVMSGS_TO_TABLE,
				'primary'		=> 'pm.id',
				'query_first'	=> array('target', $convert->truncate_statement . PRIVMSGS_TO_TABLE),

				array('msg_id',		'pm.id',					''),
				array('user_id',	'pm.user_to',	array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('author_id',	'pm.user_from',		array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('pm_deleted',	0,		''),
				array('pm_new',		'pm.user_read',				'not'),
				array('pm_unread',	'pm.user_read',				'not'),
				array('pm_replied',	0,		''),
				array('pm_marked',	0,		''),
				array('pm_forwarded',	0,		''),
				array('folder_id',	PRIVMSGS_INBOX,	''),

				//'where'			=> 'privmsgs.privmsgs_id = privmsgs_text.privmsgs_text_id
										//AND (privmsgs.privmsgs_type = 0 OR privmsgs.privmsgs_type = 1 OR privmsgs.privmsgs_type = 5)',
			),

			// Outbox
			array(
				'target'		=> PRIVMSGS_TO_TABLE,
				'primary'		=> 'pm.id',

				array('msg_id',		'pm.id',		''),
				array('user_id',	'pm.user_to',	array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('author_id',	'pm.user_from',		array('function1'=>'mysbb_get_user_id','function2'=>'mysbb_user_id')),
				array('pm_deleted',	0,										''),
				array('pm_new',		'pm.user_read',		'not'),
				array('pm_unread',	'pm.user_read',		'not'),
				array('pm_replied',	0,				''),
				array('pm_marked',	0,				''),
				array('pm_forwarded',	0,				''),
				array('folder_id',				PRIVMSGS_OUTBOX,						''),

				//'where'			=> 'privmsgs.privmsgs_id = privmsgs_text.privmsgs_text_id
										//AND (privmsgs.privmsgs_type = 1 OR privmsgs.privmsgs_type = 5)',
			),





			array(
				'target'		=> USER_GROUP_TABLE,
				'query_first'	=> array('target', $convert->truncate_statement . USER_GROUP_TABLE),
				'execute_first'	=> '
					add_default_groups();
				',

				array('group_id',	'member.usergroup',	''),
				array('user_id',	'member.id',		''),
				array('group_leader',	1,		''),
				array('user_pending',	0,		''),

				//'where'			=> '.group_single_user = 0 AND groups.group_moderator <> 0',
			),


			array(
				'target'		=> USERS_TABLE,
				'primary'		=> 'member.id',
				'autoincrement'	=> 'user_id',
				'query_first'	=> array(
					array('target', 'DELETE FROM ' . USERS_TABLE . ' WHERE user_id <> ' . ANONYMOUS),
					array('target', $convert->truncate_statement . BOTS_TABLE)
				),

				'execute_last'	=> '
					remove_invalid_users();
				',

				array('user_id',	'member.id',		'mysbb_user_id'),
				array('',		'member.id AS poster_id','mysbb_user_id'),
				array('user_type',	'member.usergroup',	'set_user_typWW'),
				array('group_id',	'member.usergroup',	'mysbb_set_primary_group'),
				array('user_regdate',	'member.register_date',	'mysbb_convert_time2'),
				array('username',	'member.username',	'mysbb_set_encoding'), // recode to utf8 with default lang
				array('username_clean',	'member.username',	array('function1' => 'mysbb_set_encoding', 'function2' => 'utf8_clean_string')),
				array('user_password',	'member.password',	''),
				array('user_pass_convert',1,		''),
				array('user_posts',	'member.posts',		'intval'),
				array('user_email',	'member.email',		'strtolower'),
				array('user_email_hash','member.email',		'gen_email_hash'),
				array('user_birthday',	 '',	'mysbb_get_birthday'),
				array('user_lastvisit',		'member.lastvisit ',	'mysbb_convert_time'),
				array('user_lastmark',	'member.lastvisit',	'mysbb_convert_time'),
				array('user_lang',		$config['default_lang'],''),
				//array('',						'users.user_lang',					''),
				array('user_timezone',		'member.user_time','floatval'),
				array('user_dateformat',	'',	array('function1' => 'mysbb_set_encoding', 'function2' => 'fill_dateformat')),
				array('user_inactive_reason',		'member.away_msg',				'mysbb_set_encoding'),
				array('user_inactive_time',		'',				'mysbb_inactive_time'),

				array('user_interests',	'member.user_info',	array('function1' => 'mysbb_set_encoding')),
				array('user_occ',	'member.user_country',	array('function1' => 'mysbb_set_encoding')),
				array('user_website',	'member.user_website',	'validate_website'),
				//array('user_jabber',			'',									''),
				//array('user_msnm',				'users.user_msnm',					array('function1' => 'phpbb_set_encoding')),
				//array('user_yim',				'users.user_yim',					array('function1' => 'phpbb_set_encoding')),
				//array('user_aim',				'users.user_aim',					array('function1' => 'phpbb_set_encoding')),
				//array('user_icq',				'users.user_icq',					array('function1' => 'phpbb_set_encoding')),
				array('user_from',	'member.user_country',		array('function1' => 'mysbb_set_encoding')),
				array('user_rank',		'','intval'),
				array('user_permissions', '',	''),

				array('user_avatar',		'member.avater_path',	'mysbb_import_avatar'),
				array('user_avatar_type',	0,	''),
				array('user_avatar_width',	0,	''),
				array('user_avatar_height',	0,	''),

				array('user_new_privmsg',	'member.unread_pm', ''),
				array('user_unread_privmsg',	0,	''), //'users.user_unread_privmsg'
				array('user_last_privmsg',	0,	'intval'),
				array('user_emailtime',		0,	'null_to_zero'),
				array('user_notify',		0,	'intval'),
				array('user_notify_pm',		0,	'intval'),
				array('user_notify_type',	NOTIFY_EMAIL,	''),
				array('user_allow_pm',		1,		'intval'),
				array('user_allow_viewonline',	'member.hide_online',	'not'),
				array('user_allow_viewemail',	1,		'intval'),
				array('user_actkey',		'member.active_number', ''),
				array('user_newpasswd',	'',''), // Users need to re-request their password...
				array('user_style',	$config['default_style'],		''),

				array('user_options',	'',		'set_user_options'),


				array('user_sig_bbcode_uid',		'member.register_date',	array('function1'=>'mysbb_convert_time2', 'function2'=>'make_uid')),
				array('user_sig',		'member.user_sig',		'mysbb_prepare_message'),
				//array('',		'users.user_sig_bbcode_uid AS old_bbcode_uid',	''),
				array('user_sig_bbcode_bitfield',	'',			'get_bbcode_bitfield'),
				//array('',	'users.user_regdate AS post_time',	''),

				//'where'			=> 'users.user_id <> -1',
			),
		),
	);
}

?>
